#ifndef EXPLORER_H
#define EXPLORER_H

#include <QListWidget>
#include <QMessageBox>
#include <QTranslator>
#include <qsqldatabase.h>
#include <data.h>
#include <QDir>
#include "thumbnailviewer.h"

class explorer
{
    public:
        explorer();
        explorer(QListWidget *qlist, thumbnailviewer *thumbs);

        int addEntry(QString name);
        int deleteEntry();
        int refresh();
        bool load();
        bool clone();
        bool merge();

        /**Stores all entries.*/
        QListWidget *listwidget;
        /**Directory handle for handling directory operations.*/
        QDir *dir;
        /**File handle for handling file operations.*/
        QFile *file;
        /**tdata object for storing and handling data.*/
        tdata *data;
        /**Database handle.*/
        QSqlDatabase db;
        /**Query for handling database operations.*/
        QSqlQuery q;

   private:
        /**Holds the thumbnailviewer for communication.*/
        thumbnailviewer *viewer;

};

#endif // EXPLORER_H
