#ifndef EXPORTDIALOG_H
#define EXPORTDIALOG_H

#include <QDialog>
#include <data.h>
#include <QFileDialog>

namespace Ui {
class exportdialog;
}

/**The exportdialog class implements an export dialog. The user can decide how the
  data is exported and what part of it. A directory is chosen and the data exported appropriately.
  */
class exportdialog : public QDialog
{
    Q_OBJECT
    
public:
    explicit exportdialog(QWidget *parent = 0);
    ~exportdialog();

    int setData(tdata *dat, int beginning, int end);

    /**The exporting begins from this index.*/
    int beginning;
    /**The exporting finishes with this index.*/
    int end;

    /**Pointer to the data which is going to be exported.*/
    tdata *data;
    
private slots:
    void on_cancel_button_clicked();

    void on_export_button_clicked();

private:
    /**The ui interface.*/
    Ui::exportdialog *ui;
};

#endif // EXPORTDIALOG_H
