#include "help.h"
#include "ui_help.h"
#include <QDir>


/**Initializes the ui and loads the appropriate html file.*/
help::help(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::help)
{
    ui->setupUi(this);
    setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowCloseButtonHint);
}

/**Sets the specified language. Returns true if a help file exists for selected language, returns false otherwise.*/
bool help::setLanguage(QString language)
{
    QString url = QCoreApplication::applicationDirPath() + "/help/"+language;
    if(QDir(url).exists()){
        url.append("/Index.html");
        ui->webView->load(QUrl::fromLocalFile(url));
        return true;
    }
    else
        return false;
}

help::~help()
{
    delete ui;
}

void help::closeEvent(QCloseEvent *){
    delete this;
}
