#ifndef IMPORTHANDLER_H
#define IMPORTHANDLER_H
#include <QListWidget>
#include <QMessageBox>
#include <QTranslator>
#include <data.h>
#include <QDir>
#include <qfiledialog.h>
#include <QSystemStorageInfo>
#include <QFileInfo>
#include <qsqldatabase.h>
#include <QStringList>



/**The importhandler class implements importing data.
  Data can be imported from file directly or from sd card.*/

QTM_USE_NAMESPACE

class importhandler
{
public:
    importhandler();

    /**Directory handle for handling directory operations.*/
    QDir *dir;
    /**File handle for handling file operations.*/
    QFile *file;
    /**Database handle.*/
    QSqlDatabase db;
    /**Query for handling database operations.*/
    QSqlQuery q;

    int importFromFile();
    int importFromDrives();
};

#endif // IMPORTHANDLER_H
