/*Copyright (C) 2012 Johannes Hiller, Michael Hoppe, Waldemar Heinrich
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*       http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*/

package de.tui.itlogger;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import com.actionbarsherlock.app.ActionBar;
import com.actionbarsherlock.app.SherlockListActivity;
import com.actionbarsherlock.view.MenuItem;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;

import com.actionbarsherlock.app.SherlockListActivity;
import com.actionbarsherlock.view.MenuItem;
/**
 * *Class for deleting old recordings
 * Lists all folders of recordings and user can click on them to 
 * delete them
 */
public class explorer extends SherlockListActivity {
	
	private List<String> item = null;
	private List<String> path = null;
	private String root="/sdcard/iTLogger";
	private TextView myPath;
	boolean delsuccess = false;
	
	/**
	 * Make the icon in the top left corner a up-button
	 * @param MenuItem {@link android.R.id.home}: the up-button 
	 */
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
        // Handle item selection
        switch (item.getItemId()) {
        	case android.R.id.home:
        		// app icon in action bar clicked; go home
        		Intent intent = new Intent(this, iTloggerPreferences.class);
        		intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
        		startActivity(intent);
        		break;
        }
        return true;
		}
	
    /** 
     * Called when the activity is first created. Defines 
     * layout and initializes the actionbar
     */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.explorer);
        myPath = (TextView)findViewById(R.id.path);
        getDir(root);
        ActionBar actionbar = getSupportActionBar();
	    actionbar.setDisplayHomeAsUpEnabled(true);
	    String title = getString(R.string.explorerview);
	    actionbar.setTitle(title);
	    
	    float totalSpace = iTloggerActivity.space.getTotalSpace(); //total disk space in bytes.
    	float usableSpace = iTloggerActivity.space.getUsableSpace(); ///unallocated / free disk space in Mbyte.
    	float procent = (usableSpace/totalSpace)*100;
    	int prozent = (int) procent;
    	
    	final ActionBar actionBar = getSupportActionBar();
        actionBar.setSubtitle(prozent+getString(R.string.freespace));
	    
    }
    /** 
     * Get the location path and list all files. 
     */
    private void getDir(String dirPath)
    {
    	//Sets the iTlogger-Path as parent
    	myPath.setText("Location: " + dirPath);
    	
    	//Create two array lists
    	item = new ArrayList<String>();
    	path = new ArrayList<String>();
    	
    	//The file and the array in which the path of the files is written
    	File f = new File(dirPath);
    	File[] files = f.listFiles();
    	
    	//Writes all the files into an array
    	for(int i=0; i < files.length; i++)
    	{
    			File file = files[i];
    			path.add(file.getPath());
    			if(file.isDirectory())
    				item.add(file.getName() + "/");
    			else
    				item.add(file.getName());
    	}
    	//Sets the filelist in an arrayadapter and displays them all
    	ArrayAdapter<String> fileList =
    	new ArrayAdapter<String>(this, R.layout.row, item);
    	setListAdapter(fileList);
    }
    /** 
     * Build an alert dialog, which contains the delete function.  
     */
	protected void onListItemClick(ListView l, View v, int position, long id) {
		
		final File file = new File(path.get(position));
		
		File files = new File("/sdcard/");
    	long totalSpace = files.getTotalSpace()/(1024*1024); //total disk space in bytes.
    	long usableSpace = files.getUsableSpace()/(1024*1024); ///unallocated / free disk space in bytes.
    	long usedSpace = (files.getTotalSpace()-files.getUsableSpace())/(1024*1024);
    	long freeSpace = files.getFreeSpace()/(1024*1024); //unallocated / free disk space in bytes.
    	
		if (file.isDirectory())
		{
				//New alert dialog asking the user if he really wants to delete
				new AlertDialog.Builder(this)
				.setIcon(R.drawable.ic_launcher)
				.setTitle("["+file.getName()+"]")
				//Cancel dialog and don't delete
				.setNegativeButton(R.string.cancel, 
						new DialogInterface.OnClickListener(){
					
					public void onClick(DialogInterface dialog, int which) {
						// TODO Auto-generated method stub
						dialog.cancel();
					}
				})
				//Delete the chosen folder
				.setPositiveButton(R.string.delete, 
						new DialogInterface.OnClickListener() {
						
							public void onClick(DialogInterface dialog, int which) 
							{
								// TODO Auto-generated method stub
								if (file.isDirectory())
								{ 
							        File[] children = file.listFiles(); 
							        for (int i = 0; i < children.length; i++) 
							        { 
							            if(children[i].isDirectory())
							        		{
							            		File[] secondchildren = children[i].listFiles();
							            		for (int j = 0; j < secondchildren.length; j++){
							            		secondchildren[j].delete();
							            	}
							        }  	
							            children[i].delete();   
							    } 
							} 
							file.delete();
							
							long freeSpace = iTloggerActivity.space.getFreeSpace();
							float totalSpace = iTloggerActivity.space.getTotalSpace(); //total disk space in bytes.
			            	float usableSpace = iTloggerActivity.space.getUsableSpace(); ///unallocated / free disk space in Mbyte.
			            	float procent = (usableSpace/totalSpace)*100;
			            	int prozent = (int) procent;
			            	
			            	final ActionBar actionBar = getSupportActionBar();
					        actionBar.setSubtitle(prozent+getString(R.string.freespace));
			            	
							if(freeSpace > 209715200){
								iTloggerActivity.firsttime=true;
							}else{
								String plsdeletefolders = getString(R.string.plsdeletefolders);
			    				Context context = getApplicationContext();
			    				int duration = Toast.LENGTH_LONG;
			    				Toast.makeText(context, plsdeletefolders, duration).show();
							}
							
							delsuccess=true;
							if(delsuccess == true)
								{
									Intent intent = new Intent(explorer.this, explorer.class);
									startActivity(intent);
									delsuccess = false;
								}
				}
			}).show();
		}
	}
	/**
	 *Overrides the back button and brings back to {@link iTloggerPreferences}
	 */
	 public void onBackPressed() {
	    	super.onBackPressed();
	    	Intent intent = new Intent(this, iTloggerPreferences.class);
			intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
			startActivity(intent);
	    }
}