/*Copyright (C) 2012 Johannes Hiller, Michael Hoppe, Waldemar Heinrich
*
*  Licensed under the Apache License, Version 2.0 (the "License");
*   you may not use this file except in compliance with the License.
*   You may obtain a copy of the License at
*
*       http://www.apache.org/licenses/LICENSE-2.0
*
*   Unless required by applicable law or agreed to in writing, software
*   distributed under the License is distributed on an "AS IS" BASIS,
*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
*   See the License for the specific language governing permissions and
*   limitations under the License.
*/
package de.tui.itlogger;


import android.location.Location;
import android.location.LocationListener;
import android.os.Bundle;

/**
 * Class for implementing and rounding up GPS
 */
public class GPS implements LocationListener {
		static int[] gps_data = new int[5];
		
        /**
         * Read in GPS and write in in an array
         * @param loc the fix at this moment
         */
        public void onLocationChanged(Location loc) {
        	
        //Write all gps data in an array
        gps_data[0]=MultDecimal(loc.getLongitude(),6);
        gps_data[1]=MultDecimal(loc.getLatitude(),6);
        gps_data[2]=MultDecimal(loc.getSpeed(),2);
        gps_data[3]=(int) loc.getAltitude();
        gps_data[4]=MultDecimal(loc.getBearing(),2);
        }
        
        /**
         * Mutlilpy the GPS data with the number of decimal places for
         * a better performance with the SQLite database
         * @param value the value that shall be rounded
         * @param decimalPlace how many decimal places shall be rounded
         */
        public int MultDecimal(double value, int decimalPlace) {
               int help=0;  
               help = (int) (value*Math.pow(10, decimalPlace));  
               return help;
        }
        
        public void onProviderDisabled(String provider) {
        } 
        public void onProviderEnabled(String provider) { 
        }
        public void onStatusChanged(String provider, int status, Bundle extras)
        {
        }
    }
